This is a utility class used by selectors and DirectoryScanner.

The functionality more properly belongs just to selectors, but unfortunately DirectoryScanner exposed these as protected methods. Thus we have to support any subclasses of DirectoryScanner that may access these methods.

This is a Singleton.

author | Hans Lellelid, hans@xmpl.org (Phing)
author | Arnout J. Kuiper, ajkuiper@wxs.nl (Ant)
author | Magesh Umasankar
author | Bruce Atherton, bruce@callenish.com (Ant)
package | phing.types.selectors

### Methods

## Retrieves the instance of the Singleton.

    getInstance()

Static

## Returns dependency information on these two files.

    isOutOfDate(\PhingFile $src, \PhingFile $target, int $granularity) : \whether

Static

If src has been modified later than target, it returns true. If target doesn't exist, it likewise returns true. Otherwise, target is newer than src and is not out of date, thus the method returns false. It also returns false if the src file doesn't even exist, since how could the target then be out of date.

### Parameters

#### $src

`\PhingFile`

the original file

#### $target

`\PhingFile`

the file being compared against

#### $granularity

`int`

the amount in seconds of slack we will give in determining out of dateness

### Returns

`\whether`the target is out of date

## Tests whether or not a string matches against a pattern.

    match(\pattern $pattern, \str $str, \isCaseSensitive $isCaseSensitive) : \<code>true</code>

Static

The pattern may contain two special characters:
'*' means zero or more characters
'?' means one and only one character

### Parameters

#### $pattern

`\pattern`

The pattern to match against. Must not be `null`.

#### $str

`\str`

The string which must be matched against the pattern. Must not be `null`.

#### $isCaseSensitive

`\isCaseSensitive`

Whether or not matching should be performed case sensitively.

### Returns

`\<code>true</code>`if the string matches against the pattern, or `false` otherwise.

## Tests whether or not a given path matches a given pattern.

    matchPath(\pattern $pattern, \str $str, \isCaseSensitive $isCaseSensitive) : \<code>true</code>

Static

### Parameters

#### $pattern

`\pattern`

The pattern to match against. Must not be `null`.

#### $str

`\str`

The path to match, as a String. Must not be `null`.

#### $isCaseSensitive

`\isCaseSensitive`

Whether or not matching should be performed case sensitively.

### Returns

`\<code>true</code>`if the pattern matches against the string, or `false` otherwise.

## Tests whether or not a given path matches the start of a given pattern up to the first "**".

    matchPatternStart(\pattern $pattern, \str $str, \isCaseSensitive $isCaseSensitive) : \whether

Static

<

p> This is not a general purpose test and should only be used if you can live with false positives. For example,

    pattern=**\a

and

    str=b

will yield

    true

.

### Parameters

#### $pattern

`\pattern`

The pattern to match against. Must not be `null`.

#### $str

`\str`

The path to match, as a String. Must not be `null`.

#### $isCaseSensitive

`\isCaseSensitive`

Whether or not matching should be performed case sensitively.

### Returns

`\whether`or not a given path matches the start of a given pattern up to the first "**".

### Properties

##

    $instance